com.jnape.palatable.lambda.functions.builtin.fn3

## Class FoldRight<A,B>

- java.lang.Object
- - com.jnape.palatable.lambda.functions.builtin.fn3.FoldRight<A,B>

- Type Parameters:
    `A` - The Iterable element type
    `B` - The accumulation type
  All Implemented Interfaces:
    Fn1<Fn2<? super A,? super Lazy<B>,? extends Lazy<B>>,Fn1<Lazy<B>,Fn1<Iterable<A>,Lazy<B>>>>, Fn2<Fn2<? super A,? super Lazy<B>,? extends Lazy<B>>,Lazy<B>,Fn1<Iterable<A>,Lazy<B>>>, Fn3<Fn2<? super A,? super Lazy<B>,? extends Lazy<B>>,Lazy<B>,Iterable<A>,Lazy<B>>, Applicative<Fn1<Lazy<B>,Fn1<Iterable<A>,Lazy<B>>>,Fn1<Fn2<? super A,? super Lazy<B>,? extends Lazy<B>>,?>>, Cartesian<Fn2<? super A,? super Lazy<B>,? extends Lazy<B>>,Fn1<Lazy<B>,Fn1<Iterable<A>,Lazy<B>>>,Fn1<?,?>>, Cocartesian<Fn2<? super A,? super Lazy<B>,? extends Lazy<B>>,Fn1<Lazy<B>,Fn1<Iterable<A>,Lazy<B>>>,Fn1<?,?>>, Contravariant<Fn2<? super A,? super Lazy<B>,? extends Lazy<B>>,Profunctor<?,Fn1<Lazy<B>,Fn1<Iterable<A>,Lazy<B>>>,Fn1<?,?>>>, Functor<Fn1<Lazy<B>,Fn1<Iterable<A>,Lazy<B>>>,Fn1<Fn2<? super A,? super Lazy<B>,? extends Lazy<B>>,?>>, Profunctor<Fn2<? super A,? super Lazy<B>,? extends Lazy<B>>,Fn1<Lazy<B>,Fn1<Iterable<A>,Lazy<B>>>,Fn1<?,?>>, Monad<Fn1<Lazy<B>,Fn1<Iterable<A>,Lazy<B>>>,Fn1<Fn2<? super A,? super Lazy<B>,? extends Lazy<B>>,?>>, MonadReader<Fn2<? super A,? super Lazy<B>,? extends Lazy<B>>,Fn1<Lazy<B>,Fn1<Iterable<A>,Lazy<B>>>,Fn1<Fn2<? super A,? super Lazy<B>,? extends Lazy<B>>,?>>, MonadRec<Fn1<Lazy<B>,Fn1<Iterable<A>,Lazy<B>>>,Fn1<Fn2<? super A,? super Lazy<B>,? extends Lazy<B>>,?>>, MonadWriter<Fn2<? super A,? super Lazy<B>,? extends Lazy<B>>,Fn1<Lazy<B>,Fn1<Iterable<A>,Lazy<B>>>,Fn1<Fn2<? super A,? super Lazy<B>,? extends Lazy<B>>,?>>

      public final class FoldRight<A,B>
      extends Object
      implements Fn3<Fn2<? super A,? super Lazy<B>,? extends Lazy<B>>,Lazy<B>,Iterable<A>,Lazy<B>>

  Given an `Iterable` of `A`s, a starting `lazy` value `B`, and a ``Fn2`<A, `Lazy`<B>, `Lazy`<B>>`, iteratively accumulate over the `Iterable`, ultimately returning a final ``Lazy`<B>` value. If the `Iterable` is empty, just return the starting ``Lazy`<B>` value. This function is computationally the iterative inverse of `FoldLeft`, but uses `Lazy` to allow support stack-safe execution.

  Example:

       Lazy<Iterable<Integer>> lazyCopy = foldRight(
           (head, lazyTail) -&gt; lazy(cons(head, () -&gt; lazyTail.value().iterator())),
           lazy(emptyList()),
           iterate(x -&gt; x + 1, 0));
       Iterable<Integer> copy = () -&gt; lazyCopy.value().iterator();
       take(3, copy).forEach(System.out::println); // prints "1, 2, 3"
       take(3, copy).forEach(System.out::println); // prints "1, 2, 3"

  For more information, read about Catamorphisms.

  See Also:
    `FoldLeft`

- - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `Lazy<B>` | `checkedApply(Fn2<? super A,? super Lazy<B>,? extends Lazy<B>> fn, Lazy<B> acc, Iterable<A> as)`
    `static <A,B> FoldRight<A,B>` | `foldRight()`
    `static <A,B> Fn2<Lazy<B>,Iterable<A>,Lazy<B>>` | `foldRight(Fn2<? super A,? super Lazy<B>,? extends Lazy<B>> fn)`
    `static <A,B> Fn1<Iterable<A>,Lazy<B>>` | `foldRight(Fn2<? super A,? super Lazy<B>,? extends Lazy<B>> fn, Lazy<B> acc)`
    `static <A,B> Lazy<B>` | `foldRight(Fn2<? super A,? super Lazy<B>,? extends Lazy<B>> fn, Lazy<B> acc, Iterable<A> as)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface com.jnape.palatable.lambda.functions.Fn3

      `apply, apply, apply, checkedApply, compose, contraMap, diMapL, discardR, flip, fn3, fn3, fn3, uncurry, widen`

    - ### Methods inherited from interface com.jnape.palatable.lambda.functions.Fn2

      `checkedApply, curried, curry, fn2, fromBiFunction, toBiFunction`

    - ### Methods inherited from interface com.jnape.palatable.lambda.functions.Fn1

      `andThen, carry, cartesian, censor, choose, cocartesian, diMap, diMapR, discardL, flatMap, fmap, fn1, fromFunction, lazyZip, listens, local, pure, pureFn1, thunk, toFunction, trampolineM, zip, zip`

    - ### Methods inherited from interface com.jnape.palatable.lambda.monad.Monad

      `join`

    - ### Methods inherited from interface com.jnape.palatable.lambda.functor.Functor

      `coerce`

- - ### Method Detail

    - #### checkedApply

          public Lazy<B> checkedApply(Fn2<? super A,? super Lazy<B>,? extends Lazy<B>> fn,
                                      Lazy<B> acc,
                                      Iterable<A> as)

      Specified by:
        `checkedApply` in interface `Fn3<Fn2<? super A,? super Lazy<B>,? extends Lazy<B>>,Lazy<B>,Iterable<A>,Lazy<B>>`

    - #### foldRight

          public static <A,B> FoldRight<A,B> foldRight()

    - #### foldRight

          public static <A,B> Fn2<Lazy<B>,Iterable<A>,Lazy<B>> foldRight(Fn2<? super A,? super Lazy<B>,? extends Lazy<B>> fn)

    - #### foldRight

          public static <A,B> Fn1<Iterable<A>,Lazy<B>> foldRight(Fn2<? super A,? super Lazy<B>,? extends Lazy<B>> fn,
                                                                 Lazy<B> acc)

    - #### foldRight

          public static <A,B> Lazy<B> foldRight(Fn2<? super A,? super Lazy<B>,? extends Lazy<B>> fn,
                                                Lazy<B> acc,
                                                Iterable<A> as)